<script>
  // Import modules
  import { json } from "d3-fetch";
  import { onMount } from "svelte";

  // Import plot code
  import Plot from "./_design_3_plot.svelte";

  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Load data
  let data;
  onMount(async () => {
    data = await json("/data/hourly_electricity_vs_gas_december.json");
  });

  // Filter the data
  let weeks = [48, 49, 50, 51, 52];
  function data_filter(data, week, city){
    return data.filter(d => d.city == city  && d.week==week);
  }

  // Set direction of the leaves
  function even_week(week){
    return week % 2 == 0; // If week is an even number, return 1. Else, return 0.
  }

  // Shift the leaves to fit the trunk
  function horizontal_shift(week){
    if(even_week(week) == 0)
      return 1;
    else 
      return 0;
  }

</script>

{#if !data}
  <p>Loading the data. Please wait...</p>
{:else}
  <div>
    <svg {width} {height}>
      <line class="trunk" x1={innerWidth/2} y1={innerHeight-45} x2={innerWidth/2} y2={45}></line>
      <g transform="translate({margin.left}, {margin.top})">
        {#each weeks as week, index}
        <Plot data={data_filter(data, week, "Chicago")}
                    index={index} 
                    week={week} 
                    city={location} 
                    even_week={even_week(week)}/>
        <text style="font-weight:100; font-size:12"
              transform=rotate(0),translate({-horizontal_shift(week)*385+400},{540-100*(index+1)})>
              Week {week}
        </text>
        {/each}
      </g>
      <g transform="translate(150,80)">
        <text style="font-weight:100; font-size:12">Monday 0 AM</text>
        <line x1=40 y1=10 x2=88 y2=110/>
      </g>
      <g transform="translate(20,80)">
        <text style="font-weight:100; font-size:12">Sunday 12 PM</text>
        <line x1=40 y1=10 x2=64 y2=69/>
      </g>
      <g transform="translate(40,500)">
        <text style="font-weight:100; font-size:14">Electricity</text>
        <rect class="electricity" x="-20" y="-10" width="10" height="10" />
      </g>
      <g transform="translate(40,520)">
        <text style="font-weight:100; font-size:14">Gas</text>
        <rect class="gas" x="-20" y="-10" width="10" height="10" />
      </g>
      <text transform="translate(20,580)">Gas and electricity consumption during December, Chicago 2014</text>
    </svg>
  </div>
{/if} 

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  line {
  stroke:black;
  }

  line.trunk {
    stroke: black;
    stroke-width: 3px;
  }
  
  text {
    text-align: center;
  }

  rect.electricity{
    fill: blue;
  }

  rect.gas{
    fill: orange;
  }
  
</style>
